##############################################################################
# REPLACE STRINGS
#
# USED NAMES:
# samplename (Speak)		= PkgName
# sampledir (ksm-speak)		= pkg-dirname = pkg-filename (ksm-xxx)
# sampleconf (speak)		= config/include file name (no extension)
# sampledm (speakd)		= the daemon (rc-script, rc-link, systemd.service)
# sample (speak)		= all others
##############################################################################

# Specfile for Speak

%define name		ksm-speak
%define version		0.0.2
%define release		5.0.0
%define _arch		noarch
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _sysddir	/etc/systemd/system
%define _uxbindir	/usr/bin
%define _uxsbindir	/usr/sbin
%define _bindir		/usr/local/bin
%define _sbindir	/usr/local/sbin
%define _rbindir	/root/bin
%define _ubindir	/home/USR/bin
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}

Summary:	Speak programs
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		Productivity/Other
Source:		%{name}.tgz
URL:		http://www.kaesmann-online.de/
#BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:	%{_arch}
#BuildRequires:	speakpkg,speakcapab
Requires:	espeak,mbrola,mbrola-de1,mbrola-de2,mbrola-de3,mbrola-de4,mbrola-de5,mbrola-de6,mbrola-de7,mbrola-de8
Requires:	ksm-lib-sh >= 5.0.0-0.0.0,ksm-multimedia
#Requires:	ksm-speak = %{version}-%{release}	# if lang pkg
#Provides:	speakd
#Conflicts:	speakd-other,libspeak == 0.0.0
#Obsoletes:	myspeakd

%description
This package contains programs for speak.
The package contains the following programs:

 ksm-espeak, ksm-mbrola

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#%makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) %{_confdir}/speak.conf
#%config %{_confdir}/speak.conf
#%config %{_scnfdir}/speak
#%attr(644,root,root)%{_confdir}/speak.conf
#%attr(644,root,root)%{_scnfdir}/speak
#%attr(644,root,root)%{_confdir}/speak.incl.rpmnew

#%attr(744,root,root)%{_rcdir}/speakd
#%attr(777,root,root)%{_sbindir}/rcspeakd
#%attr(744,root,root)%{_sbindir}/speakd.sh

%attr(755,root,root)%{_bindir}/ksm-espeak
%attr(755,root,root)%{_bindir}/ksm-mbrola

%{_datadir}/RELEASE
%{_datadir}/VERSION
#%attr(744,root,root)%{_datadir}/speakd.rc
#%{_datadir}/speakd.service

#/usr/share/applications/speak.desktop

#%{_icondir}/16x16/apps/speak.png
#%{_icondir}/22x22/apps/speak.png
#%{_icondir}/32x32/apps/speak.png
#%{_icondir}/48x48/apps/speak.png
#%{_icondir}/64x64/apps/speak.png
#%{_icondir}/96x96/apps/speak.png
#%{_icondir}/128x128/apps/speak.png
#%{_icondir}/256x256/apps/speak.png
#%{_icondir}/512x512/apps/speak.png
#/usr/share/pixmaps/speak.png

%docdir %{_man1dir}
%{_man1dir}/ksm-espeak.1.gz
%{_man1dir}/ksm-mbrola.1.gz

%docdir %{_man8dir}
#%{_man8dir}/speakd.sh.8.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
%{_docdir}/README.de

#---------------------- ORDER OF SCRIPTLETS ----------------------------------
# O=old pkg, N=new pkg

# INSTALL:
# 1. Run %pre section of N		(Arg is 1)
# 2. Install files from N
# 3. Run %post section of N		(Arg is 1)

# UNINSTALL:
# 1. Run %preun section of O		(Arg is 0)
# 2. Delete files from O
# 3. Run %postun section of O		(Arg is 0)

# UPGRADE:
#  1. Run %pre section of O		(Arg is 2)
#  2. Install files from N
#  3. Run %post section of N		(Arg is 2)
#  4. Execute install. triggers (%triggerin in other pkgs) set off by install N
#  5. Execute installation triggers of N
#  6. Execute uninstallation triggers (%triggerun) of O
#  7. Execute uninstallation triggers (of other pkgs) set off by uninstall O
#  8. Run %preun section of O		(Arg is 1)
#  9. Delete files from O not contained in N
# 10. Run %postun section of O		(Arg is 1)

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# create group and user
#ngroup='' nuser='' npwd='' ncomm='' nhomedir='' nlogsh='' ngid=0 nuid=0 ret=0

# backup config files
#test -e %{_confdir}/speak.conf && cp %{_confdir}/speak.conf %{_confdir}/speak.conf.rpmsave
#test -e %{_scnfdir}/speak && cp %{_scnfdir}/speak %{_scnfdir}/speak.rpmsave

# disable speak daemon and stop speakd
#test -x %{_bindir}/togglespeak && %{_bindir}/togglespeak -d -q > /dev/null 2>&1
#test -x %{_rcdir}/speakd && %{_rcdir}/speakd stop -q > /dev/null 2>&1

# rm links
#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
#rm -f %{_libdir}/libfuncstd-sh

# uninstall desktop files
#xdg-desktop-menu uninstall \
#	/usr/share/applications/speak.directory \
#	/usr/share/applications/speak.desktop \
#	/usr/share/applications/speak-admin.desktop

# INIT SCRIPT/SYSTEMD UNIT - uninstall Speak
#if [ -d %{_sysddir} ]; then				# systemd
#	if [ -e %{_sysddir}/speakd.service ]; then
#		systemctl stop speakd.service
#		systemctl disable speakd.service
#		rm %{_sysddir}/speakd.service
#		systemctl daemon-reload
#	fi
#else							# SysV init
#	if [ -e %{_rcdir}/speakd ]; then
#		test -x %{_rcdir}/speakd && %{_rcdir}/speakd stop > /dev/null 2>&1
#		insserv -r speakd > /dev/null 2>&1
#		rm -f %{_rcdir}/speakd
#		rm -f %{_sbindir}/rcspeakd
#	fi
#fi

#if [ "$1" == 1 ]; then					# install package
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# Definition of vars
# set config pathname. config file needs a version at first cnfvar!
#cf=%{_confdir}/speak.conf
#cnfvars=$(grep -v '^#' $cf | grep '[[:alnum:]]' | grep -v '\[' | cut -sd '=' -f1)
#cnfvars=$(echo $cnfvars | cut -d ' ' -f2-)
#f='' templ='' tmpf='' flag=''
#ret=0
#
#incf=%{_confdir}/speak.incl

# update icon cache
#gtk-update-icon-cache "/usr/share/icons/hicolor/"

# enable speak daemon
#test -x %{_bindir}/togglespeak && %{_bindir}/togglespeak -e -q > /dev/null 2>&1

# set links
#ln -sf /usr/bin/prog %{_bindir}/myprog
#ln -sf %{_libdir}/libfuncstd-sh-%{version} %{_libdir}/libfuncstd-sh

# handle include files
#if [ -e "$incf" ]; then
#	rm $incf.rpmnew
#else
#	mv $incf.rpmnew $incf
#	echo "Check $incf"
#fi

# install desktop files
#xdg-desktop-menu install --novendor \
#	/usr/share/applications/speak.directory \
#	/usr/share/applications/speak.desktop \
#	/usr/share/applications/speak-admin.desktop

# add a (new) template to speak
#f=/.../speak						# pathname of file
#templ=%{_datadir}/speak.add				# template in datadir
#tmpf=/tmp/speak					# tempfile
#flag=ksm-speak						# flag for entries
#if [ -e $f ]; then					# file exist
#	grep -q $flag $f				# look for flag
#	ret=$?
#	if [ $ret -ne 0 ]; then				# no flag found
#		cat $templ >> $f			# add entries
#	else						# flag found
#		cat $f | grep $flag > $tmpf		# get add from file
#		cmp -s $tmpf $templ			# cmp add vs. templ
#		ret=$?
#		if [ $ret -ne 0 ]; then			# templ is new
#			cat $f | grep -v $flag > $tmpf	# rm add from file
#			cp $tmpf $f
#			cat $templ >> $f		# add new entries
#		fi
#		rm -f $tmpf
#	fi
#	echo "Packag $ksm-speak: users should source $f"
#else
#	echo "Packag $ksm-speak: File $f not found!"
#fi

# INIT SCRIPT/SYSTEMD UNIT - install Speak
#if [ -d %{_sysddir} ]; then				# systemd
#	cp --preserve=mode %{_datadir}/speakd.service %{_sysddir}/
#	systemctl daemon-reload
#	systemctl enable speakd.service
#	echo "speakd is added to the bootprocess and will auto start at next boot."
#	echo "Now configure $cf"
#	echo "You may start speakd within yast or manual with:"
#	echo "systemctl start speakd.service"
#else							# SysV init
#	cp --preserve=mode %{_datadir}/speakd.rc %{_rcdir}/speakd
#	ln -sf %{_rcdir}/speakd %{_sbindir}/rcspeakd
#	insserv speakd > /dev/null 2>&1
#	echo "speakd is added to the bootprocess and will auto start at next boot."
#	echo "Now configure $cf"
#	echo "You may start speakd within yast or manual with rcspeakd start"
#fi

# install/update all users rc files
#updcmd='' usr='' u=''
#updcmd="%{_bindir}/update-speak -q"
# for all usr below /home/ do:
#usr=$(/usr/bin/grep /home/ /etc/passwd | /usr/bin/cut -d : -f 1)
#for u in $usr; do
#	/bin/su $u -c "$updcmd"
#done
#echo "Packag $ksm-speak: All users rc files have been updated"

#if [ "$1" == 1 ]; then					# install package
#	echo "Configure $cf"
#else							# upgrade package
#	# update global conf
#	if [ -e $cf.rpmsave ]; then
#		c='' s='' t=''
#		#cp $cf $cf.rpmnew
#		. $cf
#		. $cf.rpmsave
#
#		# update conf vars START -------------------------------------
#		if [ -x %{_bindir}/replcnfvar ]; then
#			for c in $cnfvars; do
#				t="\$$c"
#				eval s="$t"
#				s=\"$s\"
#				%{_bindir}/replcnfvar $cf $c "$s"
#			done
#		else
#			echo "Packag $ksm-speak: Error - cmd replcnfvar not found or not executable!" >&2
#			echo "Packag $ksm-speak: Conf file not updated!" >&2
#		fi
#		# update conf vars STOP --------------------------------------
#
#		# update array vars START ------------------------------------
#		cnt=0 i=0
#		# array var MainArr (contignous index from 0)
#		cnt=${#MainArr[@]}			# max members of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any member in use?
#			while [ "$i" -lt $cnt ]; do
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#				let ++i
#			done
#		fi
#
#		# array var MainArr (contignous index from 1)
#		cnt=${#MainArr[@]}			# max members of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any member in use?
#			while [ "$i" -lt $cnt ]; do
#				let ++i
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#			done
#		fi
#		# update array vars STOP -------------------------------------
#
#		# compare new conf vars <--> old conf vars
#		diff $cf $cf.rpmsave > /dev/null 2>&1
#		ret=$?
#		if [ "$ret" -eq 0 ]; then
#			rm $cf.rpmsave
#		else
#			echo "Check $cf"
#		fi
#	fi
#fi
# if libraries contained:
#ldconfig
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

#f='' tmpf='' flag=''
#ret=0

#if [ "$1" == 0 ]; then					# remove package
	# backup config files
	#test -e %{_confdir}/speak.conf && cp %{_confdir}/speak.conf %{_confdir}/speak.conf.rpmsave
	#test -e %{_scnfdir}/speak && cp %{_scnfdir}/speak %{_scnfdir}/speak.rpmsave

	# disable speak daemon and stop speakd
	#test -x %{_bindir}/togglespeak && %{_bindir}/togglespeak -d -q > /dev/null 2>&1
	#test -x %{_rcdir}/speakd && %{_rcdir}/speakd stop -q > /dev/null 2>&1

	# rm links
	#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
	#rm -f %{_libdir}/libfuncstd-sh

	# uninstall desktop files
	#xdg-desktop-menu uninstall \
	#	/usr/share/applications/speak.directory \
	#	/usr/share/applications/speak.desktop \
	#	/usr/share/applications/speak-admin.desktop

	# remove entries from file speak
	#f=/.../speak					# pathname of file
	#tmpf=/tmp/speak				# tempfile
	#flag=ksm-speak					# flag for entries
	#ret=0
	#if [ -e $f ]; then
	#	grep -q $flag $f			# look for flag
	#	ret=$?
	#	if [ $ret -eq 0 ]; then			# flag found
	#		cat $f | grep -v $flag > $tmpf	# rm add from file
	#		cp $tmpf $f
	#		rm -f $tmpf
	#	fi
	#else
	#	echo "Packag $ksm-speak: File $f not found!"
	#fi

	# INIT SCRIPT/SYSTEMD UNIT - uninstall Speak
	#if [ -d %{_sysddir} ]; then				# systemd
	#	if [ -e %{_sysddir}/speakd.service ]; then
	#		systemctl stop speakd.service
	#		systemctl disable speakd.service
	#		rm %{_sysddir}/speakd.service
	#		systemctl daemon-reload
	#	fi
	#else							# SysV init
	#		test -x %{_rcdir}/speakd && %{_rcdir}/speakd stop > /dev/null 2>&1
	#		insserv -r speakd > /dev/null 2>&1
	#		rm -f %{_rcdir}/speakd
	#		rm -f %{_sbindir}/rcspeakd
	#	fi
	#fi
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

# update icon cache
#gtk-update-icon-cache "/usr/share/icons/hicolor/"

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/ksm-speak
#else							# upgrade package
fi
exit 0

%changelog
* Fri Feb 24 2023 Repomaster <repomaster@kaesmann-online.de> 0.0.2-5.0.0
- 'ksm-espeak' and 'ksm-mbrola' have been revised/improved
  (changed option -p to -s).

* Tue Feb 21 2023 Repomaster <repomaster@kaesmann-online.de> 0.0.2-4.0.0
- 'ksm-espeak' and 'ksm-mbrola' have been revised/improved.

* Tue Feb 21 2023 Repomaster <repomaster@kaesmann-online.de> 0.0.2-3.0.0
- 'ksm-espeak' and 'ksm-mbrola' have been revised/improved.

* Tue Feb 21 2023 Repomaster <repomaster@kaesmann-online.de> 0.0.2-2.0.0
- 'ksm-espeak' and 'ksm-mbrola' have been revised/improved
  (added option -p).

* Mon Feb 20 2023 Repomaster <repomaster@kaesmann-online.de> 0.0.2-1.0.0
- 'ksm-espeak' and 'ksm-mbrola' have been revised/improved
  (added option -r).

* Sun Feb 19 2023 Repomaster <repomaster@kaesmann-online.de> 0.0.2-0.0.0
- The package has been revised/improved.

* Sat Feb 18 2023 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.0.0
- The package has been revised/improved.

* Sat Feb 18 2023 Repomaster <repomaster@kaesmann-online.de> 0.0.0-0.0.0
- This is the 1. version.
- The package contains following programs:
  ksm-espeak:	Speak using espeak
  ksm-mbrola:	Speak using mbrola
